/*
qgvdial is a cross platform Google Voice Dialer
Copyright (C) 2010  Yuvraaj Kelkar

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

Contact: yuvraaj@gmail.com
*/

import Qt 4.7

Item {
    id: container

    signal sigSendLogs()
    signal sigBack()

    Column {
        id: mainColumn
        anchors.fill: parent
        spacing: 1

        property int pixDiv: 15
        property int pixHeight: (container.height + container.width) / 2
        property int pixSize: pixHeight / pixDiv

        ListView {
            height: container.height - btnRow.height - mainColumn.spacing
            width: parent.width
            model: g_logModel
            clip: true

            delegate: Rectangle {
                height: logText.height + 2
                width: mainColumn.width
                color: "black"
                Text {
                    id: logText
                    text: modelData
                    color: "white"
                    width: parent.width
                    wrapMode: Text.Wrap
                    font.pixelSize: mainColumn.pixSize / 1.8
                }
            }
        }//ListView (rotating logs)

        Row {
            id: btnRow
            height: btnBack.height
            width: parent.width
            spacing: 1

            MyButton {
                id: btnSendLogs

                mainText: "Send logs"
                width: (parent.width / 2) - parent.spacing
                mainPixelSize: mainColumn.pixSize

                onClicked: container.sigSendLogs();
            }//MyButton (Send logs)

            MyButton {
                id: btnBack

                mainText: "Back"
                width: (parent.width / 2) - parent.spacing
                mainPixelSize: mainColumn.pixSize

                onClicked: container.sigBack();
            }//MyButton (Back)
        }//Button row (Send logs and Back)
    }//Column
}//Item (container)
